Subject: Re: [PATCH] Revert "Stop starting pager recursively"

From: Jörn Engel <[email-masked]>
Date: Fri, 25 Apr 2014 16:10:49 -0400

On Fri, 25 April 2014 20:49:52 +0200, Matthieu Moy wrote:
> Jörn Engel <[email-masked]> writes:
> > On Mon, 21 April 2014 16:46:22 -0400, Jörn Engel wrote:
> >> 
> >> This reverts commit 88e8f908f2b0c56f9ccf8134d8ff9f689af9cc84.
> >> 
> >> Caused a usability regression for me and foul language for my coworkers.
> >
> > Ping.
> 
> How do you solve the problem that the commit you revert was solving? The
> commit you propose to revert says in its message:
> 
>     git-column can be used as a pager for other git commands, something
>     like this:
>     
>         GIT_PAGER="git -p column --mode='dense color'" git -p branch
>     
>     The problem with this is that "git -p column" also has $GIT_PAGER set so
>     the pager runs itself again as another pager. The end result is an
>     infinite loop of forking.
> 
> There's probably a solution, but you can't ignore the problem (or
> someone else will later try to solve the infinite loop and revert your
> commit, and so on ...).

Disclaimer: I never looked at git internals before this regression
forced me to and am likely talking out of my arse.

One approach is "don't do that then".  Someone explicitly changed the
git pager to be git, which itself takes the git pager, etc.  That is
asking for infinite recursion and the original problem was that git
gave the user exactly what they asked for.

A second option is to add a --pager (or rather --no-pager) option to
the command line and allow the user to specify
    GIT_PAGER="git --no-pager -p column --mode='dense color'" git -p branch

A third option is to try to be smart and give the user what he wants,
not what he asked for.  If the pager happens to be git, unset
$GIT_PAGER, $PAGER and somehow disable core.pager.  Yeah, that will
turn nasty rather quickly.

A fourth option is to set an environment variable for the pager
process itself.  Disable paging similar to the original patch, but
make it conditional on we_are_the_pager(), not pager_in_use().

My preference is option four, but see disclaimer above.

Jörn

--
I've never met a human being who would want to read 17,000 pages of
documentation, and if there was, I'd kill him to get him out of the
gene pool.
-- Joseph Costello